﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Linq.Expressions;

namespace GridDemo.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {

        public ActionResult SortDemo(bool? desc,string sortName)
        {

            List<News> list = ListNews.GetList();
            ParameterExpression p = Expression.Parameter(typeof(News), "p");
            MemberExpression expM;
            System.Reflection.PropertyInfo propertyInfo;
            if (string.IsNullOrEmpty(sortName))
            {
                propertyInfo = typeof(News).GetProperty("ID");
            }
            else
            {
                propertyInfo=typeof(News).GetProperty(sortName);

            }
            expM = Expression.MakeMemberAccess(p, propertyInfo);
            Expression exp = Expression.Lambda(expM, p); 
            if (desc==null || desc==false)
            {
                ViewData["desc"] = true;
                return View(list.AsQueryable<News>().OrderBy(exp, true, propertyInfo.PropertyType));
            }
            else
            {
                ViewData["desc"] = false;
                return View(list.AsQueryable<News>().OrderBy(exp, false, propertyInfo.PropertyType));
            }
        }
        public ActionResult NewsPageList(int? page)
        {
            List<News> list = ListNews.GetList();
            const int pageSize = 5;
            ViewData["currentPage"] = page??0;
            ViewData["pages"] = Convert.ToInt32(Math.Ceiling((double)list.Count() / pageSize));
           
            var news = list.Skip((page ?? 0) * pageSize).Take(pageSize);
            return View(news);
        }
    }
}
